package com.mylove.okhttp;

import android.Manifest;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.util.Base64;
import android.view.View;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import com.benyanyi.loglib.Jlog;
import com.benyanyi.okhttp.OkHttpUtil;
import com.benyanyi.okhttp.download.DownloadInfo;
import com.benyanyi.okhttp.listener.OnDownLoadObserver;
import com.benyanyi.okhttp.listener.OnOkHttpListener;
import com.benyanyi.permissionlib.PermissionHelper;
import com.benyanyi.permissionlib.callback.PermissionCallBack;
import com.benyanyi.permissionlib.type.PermissionType;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

/**
 * @author myLove
 * @time 2017/11/16 19:18
 * @e-mail mylove.520.y@gmail.com
 * @overview
 */

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
//        setContentView(R.layout.notification_contentview);
        setContentView(R.layout.activity_main);
        findViewById(R.id.but).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PermissionHelper.with(MainActivity.this)
                        .setPermissions(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                        .request(new PermissionCallBack() {
                            @Override
                            public void onSuccess() {
//                                Intent intent = new Intent(MainActivity.this, DownloadActivity.class);
//                                startActivity(intent);
                                upload();
                            }
                        });
            }
        });
//        OkHttpUtil.getInstance(this).url("http://apitest.yanyi.online/app/update").getText(null).async(new OnOkHttpListener<Object>() {
//            @Override
//            public void onCompleted() {
//
//            }
//
//            @Override
//            public void onSuccess(Object message) {
//                Jlog.d(message);
//            }
//
//            @Override
//            public void onFailure(Throwable t) {
//
//            }
//        });

//        init();
//        PermissionHelper.getInstance(this).hasPermission(0x11, new PermissionCallBack() {
//            @Override
//            public void onPermissionSuccess(int permissionCode) {
//                downloadAPK();
//            }
//
//            @Override
//            public void onPermissionFailure(FailureMsg failureMsg) {
//
//            }
//
//            @Override
//            public void onPermissionComplete(int permissionCode) {
//
//            }
//        }, Manifest.permission.WRITE_EXTERNAL_STORAGE);
//        permissionHelper = new PermissionHelper(this, strings);
//        permissionHelper.hasPermission(new PermissionHelper.OnPermissionListener() {
//            @Override
//            public void onAllPermissionSuccess() {
////                init();
//                downloadAPK();
//            }
//
//            @Override
//            public void onAllPermissionFailure() {
//
//            }
//        });
//        String str = "<html></html>";
//        try {
////            JSONObject jsonObject = new JSONObject(str);
//            JsonElement jsonParser = JsonParser.parseString(str);
//            Jlog.v(jsonParser.isJsonArray());
//            Jlog.v(jsonParser.isJsonObject());
//            Jlog.v(jsonParser.isJsonPrimitive());
//            Jlog.v(jsonParser.isJsonNull());
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
    }

    public void onClick(View view) {
        String[] strings = new String[]{PermissionType.STORAGE};
        PermissionHelper.with(this).setPermissions(strings).request(new PermissionCallBack() {
            @Override
            public void onSuccess() {
                startActivity(new Intent(MainActivity.this, DownloadActivity.class));
            }
        });
    }

    private void upload() {
        String path = Environment.getExternalStorageDirectory() + "/DCIM/camera/IMG_20190620_082204.jpg";
        String path1 = Environment.getExternalStorageDirectory() + "/tencent/micromsg/weixin/mmexport1528644702092.jpg";
        File file = new File(path);
        File file1 = new File(path1);
        Map<Object, Object> oMap = new HashMap<>();
        oMap.put("sn", "2023022100001_孟*杰_0034");
        oMap.put("device_no", "123456");
        oMap.put("appid", "37bU34uZPTUjzGZTsZ8eSh");
        oMap.put("timestamp", System.currentTimeMillis() / 1000 + "");
        oMap.put("sign", sign(oMap));
        oMap.put("origin_image", fileToBase64(file));
        oMap.put("photo_image", fileToBase64(file1));
        for (Map.Entry<Object, Object> entry : oMap.entrySet()) {
            if (entry.getValue().toString().length() <= 10) {
                Jlog.d(entry.getKey() + "=" + entry.getValue());

            } else {
                Jlog.d(entry.getKey() + "=" + (entry.getValue().toString().substring(0, 20)));
            }
        }
        OkHttpUtil.getInstance(this).url("https://opend.icaiji.com.cn/wxapp/v6/photo").postText(null, oMap).async(new OnOkHttpListener<Object>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onSuccess(Object message) {
                Jlog.d(message);
            }

            @Override
            public void onFailure(Throwable t) {

            }
        });
    }

    private String sign(Map<Object, Object> oMap) {
        Map<String, String> map = new HashMap<>();
        for (Map.Entry<Object, Object> entry : oMap.entrySet()) {
            map.put(entry.getKey().toString(), entry.getValue().toString());
        }
        map.put("secret", "3sx9NNhVGEEEouhoenA5aJ");
        return MD5Utils.getSignToken(map);
    }

    private String fileToBase64(File file) {
        String base64 = null;
        InputStream in = null;
        try {
            in = new FileInputStream(file);
            byte[] bytes = new byte[in.available()];
            int length = in.read(bytes);
            base64 = Base64.encodeToString(bytes, 0, length, Base64.DEFAULT);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (in != null) {
                    in.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
            return base64;
        }
    }

    private void init() {
        String url = "http://test.zhcjrwang.com/api/Test/Index";
        Map<Object, Object> headerMap = new HashMap<>();
        headerMap.put("app_key", "XiangKeLai");
        String timeStamp = DateUtil.timeStamp();
        headerMap.put("timestamp", timeStamp);
        headerMap.put("sign", ("XiangKeLai1" + timeStamp).toUpperCase());
        Jlog.v(headerMap);
        Map<Object, Object> bodyMap = new HashMap<>();
        bodyMap.put("data", "+fAFfMCGsMZqeS+gyrZm1A==");
        Jlog.v(bodyMap);
        OkHttpUtil.getInstance(this).url(url, true).postText(headerMap, bodyMap).async(new OnOkHttpListener<Object>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onSuccess(Object message) {
                Jlog.v(message);
            }

            @Override
            public void onFailure(Throwable t) {
                Jlog.e(t.getMessage());
            }
        });
    }

    private void downloadAPK() {
//        JLog.init(true);
        String url = "http://apitest.yanyi.online/app/xiangyou.apk";
//        String filePath = "/dectector/dfu/";
////        String filePath = Environment.getExternalStorageDirectory().toString() + "/dectector/dfu/";
        OkHttpUtil.getInstance(this).url(url).download(true).start(new OnDownLoadObserver() {
            @Override
            public void onComplete() {

            }

            @Override
            public void onNext(DownloadInfo downloadInfo) {
                super.onNext(downloadInfo);
                Jlog.v(downloadInfo);
            }

            @Override
            public void onError(Throwable e) {
                super.onError(e);
                Jlog.e(e.getMessage());
            }
        });
//        OkHttpUtil.getInstance(this).downloadFile(url).downloads(filePath, new OnDownloadCallBack() {
//            @Override
//            public void onDownloading(int progress) {
//                JLog.d(progress + "");
//            }
//
//            @Override
//            public void onSuccess(String message) {
//                JLog.v(message);
//            }
//
//            @Override
//            public void onFailure(Throwable t) {
//                JLog.e(t.getMessage());
//            }
//        });
    }

}
